=== ci/official/containers/ml_build_arm64/requirements.txt ===
portpicker==1.6.0
# For wheel verification, and uploading
auditwheel ~= 6.1.0
twine ~= 6.1.0

# uv is faster than pip for installing Python packages.
uv ~= 0.5.30
