=== debian/changelog ===
tensorflow (2.20.0-1+rpt1) trixie; urgency=medium

  [ Naushir Patuck ]
  * New upstream version 2.19.1
  * New upstream version 2.20.0
  * Update for v2.20.0

 -- NAUSH-P-DELL <naush@raspberrypi.com>  Fri, 26 Sep 2025 09:37:14 +0100

tensorflow (2.19.1-1) trixie; urgency=medium

  [ Naushir Patuck ]
  * Update patches and control files for 2.17.1
  * Add libprotobuf support
  * New upstream version 2.19.1
  * Update flatbuffers-dev version to match tflite v2.19.1
  * Updates for v2.19.1
  * patch CMakeLists.txt
  * Update patches for v2.19.1

 -- NAUSH-P-DELL <naush@raspberrypi.com>  Wed, 17 Sep 2025 13:18:07 +0100

tensorflow (2.17.1-1+rpt1) trixie; urgency=medium

  [ Naushir Patuck ]
  * New upstream version 2.17.1

 -- NAUSH-P-DELL <naush@raspberrypi.com>  Tue, 16 Sep 2025 14:38:09 +0100

tensorflow (2.14.1+dfsg-2+rpt1) trixie; urgency=medium

  [ Dylan Aïssi ]
  * Add autopkgtest building a simple application using TensorFlow Lite
    and then executing it on a mobilenet model.

  [ Naushir Patuck ]
  * Update to RPi sala-ci
  * Update rules to enable XXNPACK
  * Add libxnnpack dependency
  * try find_library for xnnpack
  * Add pkgconfig file

 -- Naushir Patuck <naush@raspberrypi.com>  Fri, 05 Sep 2025 13:38:22 +0100
